avg.trait <- function(taxocenosis, taxonomy, traits, labels,
                      which.traits = unique(labels$Trait.code),
                      find.upper = FALSE, check.block = TRUE,
                      ori.col.names = FALSE){
  tab.avg <- traits
  for(i in 1:5){
    fac <- factor(taxonomy[,i])
    w <- apply(traits, 2, function(x) tapply(x, fac, mean))
    w <- data.frame(w)
    tab.avg <- rbind(tab.avg, w)
  }
  tab.res <- tab.avg[rownames(tab.avg) %in% taxocenosis, drop = FALSE,]
  tab.tax <- data.frame()
  for(i in 6:1){
    w <- taxonomy[taxonomy[,i] %in% taxocenosis,]
    w$tax.lev <- rep(7-i, nrow(w))
    if(i < 6 & length(w[,i]) > 0)
      w[(i+1):6] <- ""
    w$Species <- w[,i]
    tab.tax <- unique(rbind(tab.tax, w))
  }
  not.found <- taxocenosis[taxocenosis %in% rownames(tab.res) == FALSE]
  if(length(not.found) > 0 & find.upper == TRUE){
    for(i in 1:length(not.found)){
      w <- strsplit(not.found[i], " ")[[1]]
      if(length(w) > 1){
        genus <- w[[1]][1]
        w <- taxonomy[taxonomy[,5] %in% genus,]
        if(nrow(w) > 0){
          w <- w[1,]
          w$Species <- not.found[i]
          w$tax.lev <- 2
          tab.tax <- unique(rbind(tab.tax, w))
          w <- tab.avg[rownames(tab.avg) == genus, drop = FALSE,]
          rownames(w) <- not.found[i]
          tab.res <- rbind(tab.res, w)
        }
      }
    }
  }
  colnames(tab.tax)[6] <- "Taxon"
  tab.tax <- tab.tax[order(tab.tax$Taxon),]
  rownames(tab.tax) <- 1:nrow(tab.tax)
  tab.res <- tab.res[order(rownames(tab.res)), drop = FALSE,]
  tab.res <- tab.res[labels$Trait.code %in% which.traits]
  tab.res <- tab.res[apply(tab.res, 2, sum) > 0]
  if(check.block == TRUE){
    newlabels <- labels[labels$Column.name %in% colnames(tab.res),]
    w <- table(newlabels$Trait.code)
    w <- as.numeric(names(w)[which(w > 1)])
    newlabels <- newlabels[newlabels$Trait.code %in% w,]
    tab.res <- tab.res[colnames(tab.res) %in% newlabels$Column.name]
    labels <- labels[labels$Trait.code %in% which.traits,]
    w <- labels$Trait.code[labels$Trait.code %in% newlabels$Trait.code == FALSE]
    if(length(w) > 0){
      warning <- unique(labels$Trait[labels$Trait.code %in% w])
      warning <- paste(warning, collapse = ", ")
      warning <- paste("Warning: no variation in ", warning, sep = "")
      cat(warning, "\n")
      cat("Data discarded", "\n")
      if(length(which.traits) == 1) stop("No output", call. = FALSE)
    }
  }
  if(ori.col.names == FALSE){
    lab <- labels[labels$Column.name %in% colnames(tab.res),]
    lab$Trait.code <- rep(1:length(unique(lab$Trait.code)), table(lab$Trait.code))
    w <- numeric()
    for(i in 1:max(lab$Trait.code)){
      w <- c(w, 1:table(lab$Trait.code)[i])
    }
    lab$Modality.code <- w
    w <- paste(rep("T", ncol(tab.res)), lab$Trait.code, sep = "")
    w <- paste(w, paste(rep("M", ncol(tab.res)), lab$Modality.code, sep = ""), sep = ".")
    colnames(tab.res) <- w
    lab$Column.name <- w
  }else{
    lab <- labels[labels$Column.name %in% colnames(tab.res),]
  }
  not.found <- not.found[not.found %in% tab.tax$Taxon == FALSE]
  list(tab = tab.res, labels = lab, tax = tab.tax, not.found = not.found)
}
